From adb062a422c68adc2b2861b934386d308271f744 Mon Sep 17 00:00:00 2001
From: Pavel Borisov <pashkin.elfe@gmail.com>
Date: Fri, 13 Sep 2024 18:46:41 +0400
Subject: [PATCH] Check for interrupts during hash index builds

This is to avoid non-interruptible phase of index build.
---
 src/backend/access/hash/hashsort.c | 1 +
 1 file changed, 1 insertion(+)

diff --git a/src/backend/access/hash/hashsort.c b/src/backend/access/hash/hashsort.c
index b67b2207c05..a3fcff9e99e 100644
--- a/src/backend/access/hash/hashsort.c
+++ b/src/backend/access/hash/hashsort.c
@@ -144,6 +144,7 @@ _h_indexbuild(HSpool *hspool, Relation heapRel)
 									   hspool->low_mask);
 		Assert(hashkey >= lasthashkey);
 #endif
+		CHECK_FOR_INTERRUPTS();
 
 		/* the tuples are sorted by hashkey, so pass 'sorted' as true */
 		_hash_doinsert(hspool->index, itup, heapRel, true);
-- 
2.39.2 (Apple Git-143)

